#pragma once
#include <vector>
#include <iostream>
#include <forward_list>
#include <algorithm>

struct Node
{
	int m_id;
	float x, y, z;
	bool m_flag;

	bool operator==(const Node& a_node);
	bool operator<(const Node& a_node);
	friend std::ostream& operator<<(std::ostream&, const Node&);
};

struct FiniteElement
{
	int m_id;
	int m_material_id;
	std::vector<int> m_nodes_id;

	friend std::ostream& operator<<(std::ostream&, const FiniteElement&);
};

struct BoundaryFiniteElement
{
	int m_id;
	int m_boundary_id;
	std::vector<int> m_surface_elems_id;

	friend std::ostream& operator<<(std::ostream&, const BoundaryFiniteElement&);
};

struct Boundary
{
	std::vector<int> m_nodes;

	Boundary(int a_id1, int a_id2, int a_id3) :
		m_nodes({ a_id1, a_id2, a_id2 }) {};

	void changeId(int a_id);
	
	bool operator==(const Boundary& a_node) const;
	bool operator<(const Boundary& a_node) const;
};


struct Hash
{
	void evaluate(size_t& a_seed, const int a_element) const;
	size_t operator() (const Boundary& p) const;
};